﻿Imports System
Imports System.Collections.Generic
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Data

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.PopulateContinents()
        End If
    End Sub

    Private Sub PopulateContinents()
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Dim strQuery As String = "select ID, ContinentName from Continents"
        Dim con As SqlConnection = New SqlConnection(strConnString)
        Dim cmd As SqlCommand = New SqlCommand
        cmd.CommandType = CommandType.Text
        cmd.CommandText = strQuery
        cmd.Connection = con
        con.Open()
        ddlContinents.DataSource = cmd.ExecuteReader
        ddlContinents.DataTextField = "ContinentName"
        ddlContinents.DataValueField = "ID"
        ddlContinents.DataBind()
        con.Close()
    End Sub

    <System.Web.Services.WebMethod()> _
    Public Shared Function PopulateCountries(ByVal continentId As Integer) As ArrayList
        Dim list As ArrayList = New ArrayList
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Dim strQuery As String = "select ID, CountryName from Countries where ContinentID=@ContinentID"
        Dim con As SqlConnection = New SqlConnection(strConnString)
        Dim cmd As SqlCommand = New SqlCommand
        cmd.CommandType = CommandType.Text
        cmd.Parameters.AddWithValue("@ContinentID", continentId)
        cmd.CommandText = strQuery
        cmd.Connection = con
        con.Open()
        Dim sdr As SqlDataReader = cmd.ExecuteReader
        While sdr.Read
            list.Add(New ListItem(sdr("CountryName").ToString, sdr("ID").ToString))
        End While
        con.Close()
        Return list
    End Function

    <System.Web.Services.WebMethod()> _
    Public Shared Function PopulateCities(ByVal countryId As Integer) As ArrayList
        Dim list As ArrayList = New ArrayList
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Dim strQuery As String = "select ID, CityName from Cities where CountryID=@CountryID"
        Dim con As SqlConnection = New SqlConnection(strConnString)
        Dim cmd As SqlCommand = New SqlCommand
        cmd.CommandType = CommandType.Text
        cmd.Parameters.AddWithValue("@CountryID", countryId)
        cmd.CommandText = strQuery
        cmd.Connection = con
        con.Open()
        Dim sdr As SqlDataReader = cmd.ExecuteReader
        While sdr.Read
            list.Add(New ListItem(sdr("CityName").ToString, sdr("ID").ToString))
        End While
        con.Close()
        Return list
    End Function
    Private Sub PopulateDropDownList(ByVal list As ArrayList, ByVal ddl As DropDownList)
        ddl.DataSource = list
        ddl.DataTextField = "Text"
        ddl.DataValueField = "Value"
        ddl.DataBind()
    End Sub

    Protected Sub Submit(ByVal sender As Object, ByVal e As EventArgs)
        Dim continent As String = Request.Form(ddlContinents.UniqueID)
        Dim country As String = Request.Form(ddlCountries.UniqueID)
        Dim city As String = Request.Form(ddlCities.UniqueID)

        ' Repopulate Countries and Cities
        PopulateDropDownList(PopulateCountries(Integer.Parse(continent)), ddlCountries)
        PopulateDropDownList(PopulateCities(Integer.Parse(country)), ddlCities)
        ddlCountries.Items.FindByValue(country).Selected = True
        ddlCities.Items.FindByValue(city).Selected = True
    End Sub


End Class
